Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/retry_policy.py
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/retry_policy.py
@@ -0,0 +1,49 @@
+# (C) Copyright 2017 SUSE LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+from cassandra.policies import RetryPolicy
+
+
+class MonascaRetryPolicy(RetryPolicy):
+
+    def __init__(self, read_attempts, write_attempts, unavailable_attempts):
+
+        super(MonascaRetryPolicy, self).__init__()
+
+        self.read_attempts = read_attempts
+        self.write_attempts = write_attempts
+        self.unavailable_attempts = unavailable_attempts
+
+    def on_read_timeout(self, query, consistency, required_responses,
+                        received_responses, data_retrieved, retry_num):
+
+        if retry_num >= self.read_attempts:
+            return self.RETHROW, None
+        elif received_responses >= required_responses and not data_retrieved:
+            return self.RETRY, consistency
+        else:
+            return self.RETHROW, None
+
+    def on_write_timeout(self, query, consistency, write_type,
+                         required_responses, received_responses, retry_num):
+
+        if retry_num >= self.write_attempts:
+            return self.RETHROW, None
+        else:
+            return self.RETRY, consistency
+
+    def on_unavailable(self, query, consistency, required_replicas, alive_replicas, retry_num):
+
+        return (self.RETRY_NEXT_HOST, consistency) if retry_num < self.unavailable_attempts else (self.RETHROW, None)
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/token_range_query_manager.py
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/token_range_query_manager.py
@@ -0,0 +1,67 @@
+# (C) Copyright 2017 SUSE LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+import multiprocessing
+
+from oslo_config import cfg
+from oslo_log import log
+
+from monasca_persister.repositories.cassandra import connection_util
+
+
+LOG = log.getLogger(__name__)
+
+conf = cfg.CONF
+
+
+class TokenRangeQueryManager(object):
+    def __init__(self, cql, result_handler, process_count=None):
+        if process_count:
+            self._process_count = process_count
+        else:
+            self._process_count = multiprocessing.cpu_count()
+
+        self._pool = multiprocessing.Pool(processes=self._process_count, initializer=self._setup,
+                                          initargs=(cql, result_handler,))
+
+    @classmethod
+    def _setup(cls, cql, result_handler):
+        cls.cluster = connection_util.create_cluster()
+        cls.session = connection_util.create_session(cls.cluster)
+        cls.prepared = cls.session.prepare(cql)
+        cls.result_handler = result_handler
+
+    def close_pool(self):
+        self._pool.close()
+        self._pool.join()
+
+    def query(self, token_ring):
+
+        range_size = len(token_ring) / self._process_count + 1
+        start_index = 0
+        params = []
+        while start_index < len(token_ring):
+            end_index = start_index + range_size - 1
+            if end_index >= len(token_ring):
+                end_index = len(token_ring) - 1
+            params.append((token_ring[start_index].value, token_ring[end_index].value))
+            start_index = end_index + 1
+
+        self._pool.map(execute_query_token_range, params, 1)
+
+
+def execute_query_token_range(token_range):
+    results = TokenRangeQueryManager.session.execute(TokenRangeQueryManager.prepared.bind(token_range))
+    TokenRangeQueryManager.result_handler(results)
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/persister.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/repositories/persister.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/persister.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -29,7 +30,7 @@ class Persister(object):
 
         self._kafka_topic = kafka_conf.topic
 
-        self._database_batch_size = kafka_conf.database_batch_size
+        self._batch_size = kafka_conf.batch_size
 
         self._consumer = consumer.KafkaConsumer(
                 kafka_conf.uri,
@@ -71,7 +72,7 @@ class Persister(object):
                     LOG.exception('Error processing message. Message is '
                                   'being dropped. {}'.format(message))
 
-                if len(self._data_points) >= self._database_batch_size:
+                if len(self._data_points) >= self._batch_size:
                     self._flush()
         except Exception:
             LOG.exception(
